import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RulesetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset.html#name Ruleset#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * team block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset.html#team Ruleset#team}
     *
     * @stability stable
     */
    readonly team?: RulesetTeam[];
}
/**
 * @stability stable
 */
export interface RulesetTeam {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset.html#id Ruleset#id}.
     *
     * @stability stable
     */
    readonly id: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset.html pagerduty_ruleset}.
 *
 * @stability stable
 */
export declare class Ruleset extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/ruleset.html pagerduty_ruleset} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RulesetConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get routingKeys(): string[];
    /**
     * @stability stable
     */
    get type(): string;
    private _team?;
    /**
     * @stability stable
     */
    get team(): RulesetTeam[];
    /**
     * @stability stable
     */
    set team(value: RulesetTeam[]);
    /**
     * @stability stable
     */
    resetTeam(): void;
    /**
     * @stability stable
     */
    get teamInput(): RulesetTeam[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
