import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#acknowledgement_timeout Service#acknowledgement_timeout}.
     *
     * @stability stable
     */
    readonly acknowledgementTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_creation Service#alert_creation}.
     *
     * @stability stable
     */
    readonly alertCreation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_grouping Service#alert_grouping}.
     *
     * @stability stable
     */
    readonly alertGrouping?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_grouping_timeout Service#alert_grouping_timeout}.
     *
     * @stability stable
     */
    readonly alertGroupingTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#auto_resolve_timeout Service#auto_resolve_timeout}.
     *
     * @stability stable
     */
    readonly autoResolveTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#description Service#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#escalation_policy Service#escalation_policy}.
     *
     * @stability stable
     */
    readonly escalationPolicy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#name Service#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * alert_grouping_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#alert_grouping_parameters Service#alert_grouping_parameters}
     *
     * @stability stable
     */
    readonly alertGroupingParameters?: ServiceAlertGroupingParameters[];
    /**
     * incident_urgency_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#incident_urgency_rule Service#incident_urgency_rule}
     *
     * @stability stable
     */
    readonly incidentUrgencyRule?: ServiceIncidentUrgencyRule[];
    /**
     * scheduled_actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#scheduled_actions Service#scheduled_actions}
     *
     * @stability stable
     */
    readonly scheduledActions?: ServiceScheduledActions[];
    /**
     * support_hours block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#support_hours Service#support_hours}
     *
     * @stability stable
     */
    readonly supportHours?: ServiceSupportHours[];
}
/**
 * @stability stable
 */
export interface ServiceAlertGroupingParametersConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#aggregate Service#aggregate}.
     *
     * @stability stable
     */
    readonly aggregate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#fields Service#fields}.
     *
     * @stability stable
     */
    readonly fields?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#timeout Service#timeout}.
     *
     * @stability stable
     */
    readonly timeout?: number;
}
/**
 * @stability stable
 */
export interface ServiceAlertGroupingParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#config Service#config}
     *
     * @stability stable
     */
    readonly config?: ServiceAlertGroupingParametersConfig[];
}
/**
 * @stability stable
 */
export interface ServiceIncidentUrgencyRuleDuringSupportHours {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#urgency Service#urgency}.
     *
     * @stability stable
     */
    readonly urgency?: string;
}
/**
 * @stability stable
 */
export interface ServiceIncidentUrgencyRuleOutsideSupportHours {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#urgency Service#urgency}.
     *
     * @stability stable
     */
    readonly urgency?: string;
}
/**
 * @stability stable
 */
export interface ServiceIncidentUrgencyRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#urgency Service#urgency}.
     *
     * @stability stable
     */
    readonly urgency?: string;
    /**
     * during_support_hours block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#during_support_hours Service#during_support_hours}
     *
     * @stability stable
     */
    readonly duringSupportHours?: ServiceIncidentUrgencyRuleDuringSupportHours[];
    /**
     * outside_support_hours block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#outside_support_hours Service#outside_support_hours}
     *
     * @stability stable
     */
    readonly outsideSupportHours?: ServiceIncidentUrgencyRuleOutsideSupportHours[];
}
/**
 * @stability stable
 */
export interface ServiceScheduledActionsAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#name Service#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface ServiceScheduledActions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#to_urgency Service#to_urgency}.
     *
     * @stability stable
     */
    readonly toUrgency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#at Service#at}
     *
     * @stability stable
     */
    readonly at?: ServiceScheduledActionsAt[];
}
/**
 * @stability stable
 */
export interface ServiceSupportHours {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#days_of_week Service#days_of_week}.
     *
     * @stability stable
     */
    readonly daysOfWeek?: number[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#end_time Service#end_time}.
     *
     * @stability stable
     */
    readonly endTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#start_time Service#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#time_zone Service#time_zone}.
     *
     * @stability stable
     */
    readonly timeZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html#type Service#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html pagerduty_service}.
 *
 * @stability stable
 */
export declare class Service extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/service.html pagerduty_service} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServiceConfig);
    private _acknowledgementTimeout?;
    /**
     * @stability stable
     */
    get acknowledgementTimeout(): string;
    /**
     * @stability stable
     */
    set acknowledgementTimeout(value: string);
    /**
     * @stability stable
     */
    resetAcknowledgementTimeout(): void;
    /**
     * @stability stable
     */
    get acknowledgementTimeoutInput(): string | undefined;
    private _alertCreation?;
    /**
     * @stability stable
     */
    get alertCreation(): string;
    /**
     * @stability stable
     */
    set alertCreation(value: string);
    /**
     * @stability stable
     */
    resetAlertCreation(): void;
    /**
     * @stability stable
     */
    get alertCreationInput(): string | undefined;
    private _alertGrouping?;
    /**
     * @stability stable
     */
    get alertGrouping(): string;
    /**
     * @stability stable
     */
    set alertGrouping(value: string);
    /**
     * @stability stable
     */
    resetAlertGrouping(): void;
    /**
     * @stability stable
     */
    get alertGroupingInput(): string | undefined;
    private _alertGroupingTimeout?;
    /**
     * @stability stable
     */
    get alertGroupingTimeout(): number;
    /**
     * @stability stable
     */
    set alertGroupingTimeout(value: number);
    /**
     * @stability stable
     */
    resetAlertGroupingTimeout(): void;
    /**
     * @stability stable
     */
    get alertGroupingTimeoutInput(): number | undefined;
    private _autoResolveTimeout?;
    /**
     * @stability stable
     */
    get autoResolveTimeout(): string;
    /**
     * @stability stable
     */
    set autoResolveTimeout(value: string);
    /**
     * @stability stable
     */
    resetAutoResolveTimeout(): void;
    /**
     * @stability stable
     */
    get autoResolveTimeoutInput(): string | undefined;
    /**
     * @stability stable
     */
    get createdAt(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _escalationPolicy;
    /**
     * @stability stable
     */
    get escalationPolicy(): string;
    /**
     * @stability stable
     */
    set escalationPolicy(value: string);
    /**
     * @stability stable
     */
    get escalationPolicyInput(): string;
    /**
     * @stability stable
     */
    get htmlUrl(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastIncidentTimestamp(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _alertGroupingParameters?;
    /**
     * @stability stable
     */
    get alertGroupingParameters(): ServiceAlertGroupingParameters[];
    /**
     * @stability stable
     */
    set alertGroupingParameters(value: ServiceAlertGroupingParameters[]);
    /**
     * @stability stable
     */
    resetAlertGroupingParameters(): void;
    /**
     * @stability stable
     */
    get alertGroupingParametersInput(): ServiceAlertGroupingParameters[] | undefined;
    private _incidentUrgencyRule?;
    /**
     * @stability stable
     */
    get incidentUrgencyRule(): ServiceIncidentUrgencyRule[];
    /**
     * @stability stable
     */
    set incidentUrgencyRule(value: ServiceIncidentUrgencyRule[]);
    /**
     * @stability stable
     */
    resetIncidentUrgencyRule(): void;
    /**
     * @stability stable
     */
    get incidentUrgencyRuleInput(): ServiceIncidentUrgencyRule[] | undefined;
    private _scheduledActions?;
    /**
     * @stability stable
     */
    get scheduledActions(): ServiceScheduledActions[];
    /**
     * @stability stable
     */
    set scheduledActions(value: ServiceScheduledActions[]);
    /**
     * @stability stable
     */
    resetScheduledActions(): void;
    /**
     * @stability stable
     */
    get scheduledActionsInput(): ServiceScheduledActions[] | undefined;
    private _supportHours?;
    /**
     * @stability stable
     */
    get supportHours(): ServiceSupportHours[];
    /**
     * @stability stable
     */
    set supportHours(value: ServiceSupportHours[]);
    /**
     * @stability stable
     */
    resetSupportHours(): void;
    /**
     * @stability stable
     */
    get supportHoursInput(): ServiceSupportHours[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
